<template>
    <router-view
        v-if="pageReady"
    />
</template>

<script setup>
import {CONFIG} from "~/config.js";
import {computed, inject, nextTick, onBeforeUnmount, onMounted, ref} from "vue";
import {useRoute, useRouter} from "vue-router";
import {useLocaleStore} from "~/stores/locale.js";
import {useUserStore} from "~/stores/user.js";
import {useSettingStore} from "~/stores/setting.js";

const $route = useRoute();
const $router = useRouter();
const $localeStore = useLocaleStore();
const locale = computed(() => {
    return $localeStore.locale || CONFIG.DEFAULT_LOCALE;
});

const $bus = inject('$bus');
const $helper = inject('$helper');
const pageReady = ref(false);
const $settingStore = useSettingStore();
const $userStore = useUserStore();
const user = computed(() => {
    return $userStore.account;
})
const token = computed(() => {
    return $userStore.token;
});

onMounted(async () => {
    try {
        await $settingStore.checkIfShouldRefreshFromServer();
        if (token.value) {
            await $userStore.updateAxios();
            await $userStore.checkIfShouldRefreshFromServer();
        }

        if (token.value && !user.value) {
            await $userStore.loginAccount(token.value);
            await nextTick(async () => {
                //IF LOGGED IN BUT IN THE GUEST ROUTE
                if (user.value && $route.meta.auth === false) {
                    await $router.push({name: 'user.home'});
                }
            });
        }
    } catch (e) {
        console.log(e);
    } finally {
        pageReady.value = true;
    }
});

const currentScrollTop = ref(0);

$bus.on('add-body-class', classes => {
    if (Array.isArray(classes)) {
        document.body.classList.add(...classes);
    } else {
        document.body.classList.add(classes);
    }
});
$bus.on('remove-body-class', classes => {
    if (Array.isArray(classes)) {
        document.body.classList.remove(...classes);
    } else {
        document.body.classList.remove(classes);
    }
});
$bus.on('modal-opened', () => {
    currentScrollTop.value = document.documentElement.scrollTop;
    window.scrollTo({ top: 0, behavior: 'smooth' });
    document.body.classList.add(...['overflow-y-hidden', 'h-screen']);
});
$bus.on('modal-closed', () => {
    document.body.classList.remove(...['overflow-y-hidden', 'h-screen']);
    window.scrollTo({ top: currentScrollTop.value, behavior: 'smooth' });
    currentScrollTop.value = 0;
});
onBeforeUnmount(() => {
    $bus.off('add-body-class');
    $bus.off('remove-body-class');
    $bus.off('modal-opened');
    $bus.off('modal-closed');
})
</script>
